import * as i0 from '@angular/core';
import { InjectionToken, Injector, Component, ChangeDetectionStrategy, Inject, NgModule, Injectable } from '@angular/core';
import * as i2 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import * as i1 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import { __awaiter } from 'tslib';
import { firstValueFrom } from 'rxjs';

/**
 * Injection token for a custom dialog component to receive input. See {@link DialogData.slDialogData}.
 */
const SL_DIALOG_DATA = new InjectionToken('SL_DIALOG_DATA');
/**
 * The {@link DialogButton.value} for the default "OK" button that is used if you do not specify any custom buttons for your dialog.
 */
const DEFAULT_OK_VALUE = Symbol('OK');
class DialogComponent {
    constructor(data, injector) {
        var _a;
        this.data = data;
        (_a = data.buttons) !== null && _a !== void 0 ? _a : (data.buttons = [{ text: 'OK', value: DEFAULT_OK_VALUE }]);
        this.componentInjector = Injector.create({
            providers: [{ provide: SL_DIALOG_DATA, useValue: data.slDialogData }],
            parent: injector,
        });
    }
}
DialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: DialogComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
DialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.0.2", type: DialogComponent, selector: "sl-dialog", ngImport: i0, template: "<h2 mat-dialog-title>{{ data.title ?? data.component?.title }}</h2>\r\n\r\n<mat-dialog-content class=\"mat-typography\">\r\n  <p *ngIf=\"data.text\">{{ data.text }}</p>\r\n  <ng-container *ngIf=\"data.component\">\r\n    <ng-container\r\n      *ngComponentOutlet=\"data.component; injector: componentInjector\"\r\n    ></ng-container>\r\n  </ng-container>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions align=\"end\">\r\n  <button\r\n    *ngFor=\"let button of data.buttons\"\r\n    mat-button\r\n    [mat-dialog-close]=\"button.value ?? button.text\"\r\n    [color]=\"button.color ?? 'primary'\"\r\n  >\r\n    {{ button.text }}\r\n  </button>\r\n</mat-dialog-actions>\r\n", styles: ["mat-dialog-actions button{text-transform:uppercase}\n"], components: [{ type: i1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }], directives: [{ type: i2.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { type: i2.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3.NgComponentOutlet, selector: "[ngComponentOutlet]", inputs: ["ngComponentOutlet", "ngComponentOutletInjector", "ngComponentOutletContent", "ngComponentOutletNgModuleFactory"] }, { type: i2.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]" }, { type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: DialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sl-dialog', changeDetection: ChangeDetectionStrategy.OnPush, template: "<h2 mat-dialog-title>{{ data.title ?? data.component?.title }}</h2>\r\n\r\n<mat-dialog-content class=\"mat-typography\">\r\n  <p *ngIf=\"data.text\">{{ data.text }}</p>\r\n  <ng-container *ngIf=\"data.component\">\r\n    <ng-container\r\n      *ngComponentOutlet=\"data.component; injector: componentInjector\"\r\n    ></ng-container>\r\n  </ng-container>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions align=\"end\">\r\n  <button\r\n    *ngFor=\"let button of data.buttons\"\r\n    mat-button\r\n    [mat-dialog-close]=\"button.value ?? button.text\"\r\n    [color]=\"button.color ?? 'primary'\"\r\n  >\r\n    {{ button.text }}\r\n  </button>\r\n</mat-dialog-actions>\r\n", styles: ["mat-dialog-actions button{text-transform:uppercase}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }, { type: i0.Injector }];
    } });

/**
 * Import this module to enable use of {@linkcode SlDialogService}
 */
class SlDialogModule {
}
SlDialogModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: SlDialogModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SlDialogModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: SlDialogModule, declarations: [DialogComponent], imports: [CommonModule, MatButtonModule, MatDialogModule] });
SlDialogModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: SlDialogModule, imports: [[CommonModule, MatButtonModule, MatDialogModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: SlDialogModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, MatButtonModule, MatDialogModule],
                    declarations: [DialogComponent],
                }]
        }] });

/**
 * Shows simple text dialogs with just a method call, and reduces boilerplate for more complex dialogs.
 *
 * A simple text dialog:
 * ```ts
 * const choice = await slDialogService.open({
 *   text: 'Discard draft?',
 *   buttons: [{ text: 'Cancel' }, { text: 'Discard' }]
 * });
 * if (choice === 'Discard') {
 *   // discard the draft
 * }
 * ```
 *
 * Using a custom component:
 * ```ts
 * @Component({
 *   template: `
 *     <h3>Heading 1</h3>
 *     <p>Paragraph 1</p>
 *     <h3>Heading 2</h3>
 *     <p>Paragraph 2</p>
 *   `
 * })
 * class FancyDialogComponent {}
 *
 * slDialogService.open({
 *   title: 'My title',
 *   component: FancyDialogComponent,
 * });
 * ```
 */
class SlDialogService {
    constructor(matDialog) {
        this.matDialog = matDialog;
    }
    /**
     * Resolves when the dialog is closed. Resolves to the {@link DialogButton.value} of the clicked button, or to `undefined` if the dialog was closed another way (such as clicking off it).
     */
    open(data) {
        return __awaiter(this, void 0, void 0, function* () {
            const ref = this.matDialog.open(DialogComponent, {
                data,
                autoFocus: false,
            });
            return firstValueFrom(ref.beforeClosed());
        });
    }
}
SlDialogService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: SlDialogService, deps: [{ token: i2.MatDialog }], target: i0.ɵɵFactoryTarget.Injectable });
SlDialogService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: SlDialogService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: SlDialogService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: i2.MatDialog }]; } });

/*
 * Public API Surface of ng-mat-core
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DEFAULT_OK_VALUE, SL_DIALOG_DATA, SlDialogModule, SlDialogService };
//# sourceMappingURL=ng-mat-core.mjs.map
